# Docker image and Azure Container Registry
# Build a Docker image and push it to an Azure Container Registry.
# https://docs.microsoft.com/azure/devops/pipelines/languages/docker

pool:
  name: 'MySgrProduction'

trigger:
  branches:
    include:
    - staging
  paths:
    include:
    - sources/back-end
    - pipelines/inventoryasset-staging.yml

resources:
- repo: self

variables:

  #===============================
  # Service Connections
  #===============================
  dockerRegistryServiceConnection: Sungroup
  kubernetesServiceEndpoint: aks-mysgr-staging

  #===============================
  # Build Variables
  #===============================
  imageRepository: 'paperless/inventoryasset-stg'
  containerRegistry: 'sungroup.azurecr.io'
  dockerfilePath: '$(Build.SourcesDirectory)/sources/back-end/Dockerfile'
  buildContext: '$(Build.SourcesDirectory)/sources/back-end'
  tag: '$(Build.BuildNumber)'

stages:
- stage: Build
  displayName: Build stage
  jobs:
  - job: Build
    displayName: Build
    steps:
    - task: Docker@2
      displayName: Build and push an image to container registry
      inputs:
        command: buildAndPush
        repository: $(imageRepository)
        containerRegistry: $(dockerRegistryServiceConnection)
        dockerfile: $(dockerfilePath)
        buildContext: $(buildContext)
        tags: |
          $(tag)
          latest

- stage: Deploy
  displayName: Deploy stage
  dependsOn: Build
  jobs:
  - deployment: deploy
    displayName: Deploy to Development environment
    environment: staging
    strategy:
      runOnce:
        deploy:
          steps:
          - task: Kubernetes@1
            name: get_deploy
            displayName: 'Get deployments in the staging namespace'
            continueOnError: true
            inputs:
              command: get
              namespace: staging-inventoryasset
              arguments: pods
              kubernetesServiceEndpoint: $(kubernetesServiceEndpoint)
          - task: Kubernetes@1
            name: change_image_tag
            displayName: 'Change image tag/version'
            continueOnError: true
            inputs:
              command: set
              namespace: staging-inventoryasset
              arguments: image deployment/inventoryasset-deployment inventoryasset=$(containerRegistry)/$(imageRepository):$(tag) --record
              kubernetesServiceEndpoint: $(kubernetesServiceEndpoint)